import java.awt.Image;
import java.awt.image.BufferedImage;

public class BufferedImageFilterAsImageFilter implements ImageFilter {
	private BufferedImageFilter bufImgFilter;
	private BufferedImage imgBuffer;
	
	public BufferedImageFilterAsImageFilter(BufferedImageFilter bufImgFilter) {
		this.bufImgFilter = bufImgFilter;
		this.imgBuffer = null;
	}
	
	public Image createFilteredImage(Image img) {
		// Copy the data from the original image into the image buffer
		this.imgBuffer = BufferedImages.copyImageToARGBBufferedImage(img, this.imgBuffer);
		
		// Filter the image
		bufImgFilter.filter(imgBuffer);
		
		// Return the filtered image
		return imgBuffer;
	}
	
	public String toString() {
		return bufImgFilter.toString();
	}
}