// EXPERIMENTAL
public class BarrelHilighterFilter implements PixelFilter, ParameterizedFilter {
	private final BooleanFilterParam clipNegativesParam =
		new BooleanFilterParam("Clip Negatives", true);
	private final IntFilterParam thresholdParam =
		new IntFilterParam("Threshold", -255, 255, 0);
	
	private final FilterParam[] params = new FilterParam[] {
		clipNegativesParam,
		thresholdParam
	};
	
	// ### FILTER ###
	
	public int filter(int pixel) {
		int delta = Pixels.getRed(pixel) - Pixels.getGreen(pixel);		// [-255, 255]
		if (delta < thresholdParam.getValue())
			delta = -255;	// minimum value
		
		int normalizedDelta = clipNegativesParam.getValue()				// [0,255]
			? ((delta < 0) ? 0 : delta)
			: (128 + delta/2);
		return Pixels.packPixel(
			Pixels.getAlpha(pixel),			// alpha
			normalizedDelta,				// red
			normalizedDelta,				// green
			normalizedDelta);				// blue
	}
	
	public String toString() {
		return "Barrel Hilighter [Orange = Red-Green]";
	}
	
	// ### PARAMETERIZED FILTER ###
	
	public FilterParam[] getParams() {
		return params;
	}
}